---
{{ template "common.StatefulSet" (list . "loki.Statefulset") }}

{{- define "loki.Statefulset" }}
spec:
  replicas: 1
  template:
    metadata:
      annotations:
        checksum.helm.sh/configmap: {{ include (print $.Template.BasePath "/configmap.yaml") . | sha256sum }}
    spec:
      containers:
        - {{- include "common.StatefulSet.container" (list . "loki.StatefulSet.container") | nindent 10 }}
      volumes:
        - name: config
          configMap:
            name: {{ template "common.fullname" . }}-config
  volumeClaimTemplates:
    - metadata:
        name: data
      spec:
        accessModes:
          - ReadWriteOnce
        resources:
          requests:
            storage: {{ .Values.statefulset.volumeClaim.capacity }}
{{- end }}

{{- define "loki.StatefulSet.container" }}
name: loki
args:
  - --config.file=/etc/loki/loki.yaml
  {{- with .Values.statefulset.extraArgs }}
    {{- toYaml . | nindent 2 }}
  {{- end }}
volumeMounts:
  - name: config
    mountPath: /etc/loki/
    readOnly: true
  - name: data
    mountPath: /data/
ports:
  - name: http
    protocol: TCP
    containerPort: 3100
livenessProbe:
  httpGet:
    scheme: HTTP
    path: /ready
    port: http
  initialDelaySeconds: 120
  periodSeconds: 10
  timeoutSeconds: 1
  successThreshold: 1
  failureThreshold: 3
readinessProbe:
  httpGet:
    scheme: HTTP
    path: /ready
    port: http
  initialDelaySeconds: 120
  periodSeconds: 10
  timeoutSeconds: 1
  successThreshold: 1
  failureThreshold: 3
{{- end }}

---
{{ template "common.Service.headless" (list .) }}
